<?php
/*---------------------------------------------------+
| PHP-Fusion 7 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+----------------------------------------------------+
| Released under the terms & conditions of v2 of the
| GNU General Public License. For details refer to
| the included gpl.txt file or visit http://gnu.org
+----------------------------------------------------+
| Multi Contact for PHP-Fusion 7
+----------------------------------------------------+
| Multi_Contact Infusion 2.00
| Author: Douwe Yntema
| Download:
| http://www.douwe.schoonheidssalonanneke.nl
+----------------------------------------------------*/

// Generates a random password with given length
function getNewPassword($length = 12) {
		$chars = array("abcdefghijklmnpqrstuvwxyzABCDEFGHIJKLMNPQRSTUVWXYZ", "123456789");
		$count = array((strlen($chars[0]) - 1), (strlen($chars[1]) - 1));

		if ($length > 64) { $length = 64; }

		$pass = "";
		for ($i = 0; $i <= $length; $i++) {
			$type = mt_rand(0, 1);
			$pass .= substr($chars[$type], mt_rand(0, $count[$type]), 1);
		}

		return $pass;
	}


// Generate a random password salt
function getNewRandomSalt($length = 12) {
		return sha1(getNewPassword($length));
	}

function hashPassword($password, $algorithm, $salt) {
		if ($algorithm != "md5") {
			return hash_hmac($algorithm, $password, $salt);
		} else {
			return md5(md5($password));
		}
	}

// Fill not required userfields
function mcsetEmptyFields(&$dbFields, &$dbValues) {
			mcsetDBValue("user_hide_email", 1,$dbFields,$dbValues);
			mcsetDBValue("user_avatar", "",$dbFields,$dbValues);
			mcsetDBValue("user_posts", 0,$dbFields,$dbValues);
			mcsetDBValue("user_threads", 0,$dbFields,$dbValues);
			mcsetDBValue("user_joined", time(),$dbFields,$dbValues);
			mcsetDBValue("user_lastvisit", 0,$dbFields,$dbValues);
			mcsetDBValue("user_ip", USER_IP,$dbFields,$dbValues);
			mcsetDBValue("user_ip_type", USER_IP_TYPE,$dbFields,$dbValues);
			mcsetDBValue("user_rights", "",$dbFields,$dbValues);
			mcsetDBValue("user_groups", "",$dbFields,$dbValues);
			mcsetDBValue("user_level", 101,$dbFields,$dbValues);
			mcsetDBValue("user_status", 2,$dbFields,$dbValues);
			mcsetDBValue("user_actiontime", 0,$dbFields,$dbValues);
			
			}

// Fill required userfields
function mcsetRequiredFields($user_name, $user_salt,$user_password,$user_email,&$dbFields, &$dbValues) {
			mcsetDBValue("user_name", $user_name,$dbFields,$dbValues);
			mcsetDBValue("user_algo", "sha256",$dbFields,$dbValues);
			mcsetDBValue("user_salt", $user_salt,$dbFields,$dbValues);
			mcsetDBValue("user_password", $user_password,$dbFields,$dbValues);
			mcsetDBValue("user_admin_password", "",$dbFields,$dbValues);
			mcsetDBValue("user_email", $user_email,$dbFields,$dbValues);
}

// Fill custom userfields
function mcsetCustomUserFieldsData($field, $value, &$dbFields, &$dbValues) {
		global $locale;
		if (file_exists(LOCALE.LOCALESET."user_fields/".$field.".php")) {
			include LOCALE.LOCALESET."user_fields/".$field.".php";
		}
		include INCLUDES."user_fields/".$field."_include_var.php";	
		
		$dbFields .= ($dbFields != "" ? ", " : "").$user_field_dbname;
		$dbValues .= ($dbValues != "" ? ", " : "")."'".$value."'";
}

// Make vars for inserting data in usertable
function mcsetDBValue($field, $value, &$dbFields, &$dbValues) {
		$dbFields .= ($dbFields != "" ? ", " : "").$field;
		$dbValues .= ($dbValues != "" ? ", " : "")."'".$value."'";
}

function dbarrayassoc($result){   
   if(dbrows($result) > 0)   {
      $output = array();
      while($data = dbarray($result)){
         $output[] = $data['user_name'];
      }
      return $output;
   }else{
      return false;
   }
}

// Generate unique username
function mcsettUserName($name) {
		$available = false;
		$current  = 1;
		$ceiling  = 15; // This is to avoid infinite loops. Increase this if necessary.		
		$name =  strtolower($name);
		$query = "SELECT LCASE(user_name)as user_name FROM ".DB_USERS." WHERE (user_name LIKE '".$name."%')";	
		$result = dbquery($query);
		$existing = dbarrayassoc($result);
		$query = "SELECT LCASE(user_code) as user_name FROM ".DB_NEW_USERS. " WHERE (user_code LIKE '".$name."%')";	
		$result = dbquery($query);
		$existingnew = dbarrayassoc($result);	
		
		while($current < $ceiling) {
			if ($current < 10) {
				$username = $name ."0".$current;
			} else {
				$username = $name . $current;
			}

			if((!in_array($username, $existing)) and (!in_array($username, $existingnew))) {
				$available = true;
				break;
			}
			$current++;
		}
//		if($current == $ceiling){
//			echo("Sorry ,there already (".$ceiling.") entries of this username.");
//		}				
	if ($available == true) {
		return $username;
	}
}


// Check if Email is valid and not already in use
function mcsetEmail($userEmail) {
	$available = True;
	if (preg_check("/^[-0-9A-Z_\.]{1,50}@([-0-9A-Z_\.]+\.){1,50}([0-9A-Z]){2,4}$/i", $userEmail)) {
		$email_domain = substr(strrchr($userEmail, "@"), 1);
		if (dbcount("(blacklist_id)", DB_BLACKLIST, "blacklist_email='".$userEmail."' OR blacklist_email='".$email_domain."'") != 0) {
			$available = False;
		} else {
			$email_active = dbcount("(user_id)", DB_USERS, "user_email='".$userEmail."'");
			$email_inactive = dbcount("(user_code)", DB_NEW_USERS, "user_email='".$userEmail."'");
//			if ($email_active == 0 && $email_inactive == 0) {
			// Same e-mail address may be used max 4 times //
			if ($email_active >= 4 || $email_inactive != 0) {
				$available = False;
			} 
		}
	} else {
		$available = False;
	}
	if ($available == true) {
		return $userEmail;
	}
}
?>
